#include <GL/glut.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <math.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <glib.h>

#include <files.hpp>
#include <config.hpp>


#define max_size 5
#define file_div 1000
#define BUFSIZE 256 // FIXME more significant name must be given


using namespace std;

typedef struct {

    float mloc;
    float eloc;
    float zloc;

} levelLocation;


static float ratio, cr;
static float angle, deltaAngle, x, z, lx, ly, lz, oldMouseH=0; //these are used for moving around
static float y; // for now y is shared with files module, a terrible hack!

static int swV2, tsw, swV1; //these are all used to switch levels
static int overFile, view, goDown, goUp, goZ, showNames, showAllNames, fSelectCT, displayInfo = 0, rotateCube, fogOnOff = 1, fOrB = 0;

// Current level
static unsigned int clevel;

static double fps,frame,mouseF,yConv=0,xConv=0;
static int ftime,timebase,mouseTime,mouseTB,deltaMove,oldMouseX,oldMouseY;
static int specialKey;

static GLuint selectBuf[BUFSIZE];
static GLuint *mptr = NULL;

static int fullscreen = 0, xmouse, ymouse, mouseMove = 0;
static const int wx = 1024, wy = 768; //window x,y size
static const int wxp = 100, wyp = 100; //window x,y position

/*
 * On future, probably we will accept textures maps also
 */
static GLfloat fileColor[3];
static GLfloat dirColor[3];
static GLfloat pdirColor[3];
static GLfloat fogColor[4];

static const int mouse_delay = 1; //mouse delay in seconds
static int fMode = 0; //0 = nothing, 1 = copy, 2 = move, 3 = delete
static int mouseStop = 0;

static char fSelect[256];
static gchar *mouseOver;

static int mainWindow;	//main glut window


static fileMap fileMap;
static levelLocation levels[fileMap.maxLevels];



static void setZ(unsigned int level, float zl, float ze)
{
    g_return_if_fail (level < fileMap.maxLevels);

    levels[level].zloc = zl;
    levels[level].eloc = ze;
    levels[level].mloc = ze + ((zl - ze)/2);
}

static double getBoxSize (unsigned int level, unsigned int number)
{
    double tmp;

    if (fileMap.is_pdir(level, number))
        return (0.5);
    tmp = fileMap.size(level, number)/file_div;
    if (tmp < max_size)
        return tmp;
    else
        return max_size;
}

static void moveMeFlat(float i) {
	x += i*(lx)*0.1;
	z += i*(lz)*0.1;
	glLoadIdentity();
	gluLookAt(x, y, z,x + lx,y + ly,z + lz,0.0f,1.0f,0.0f);
}

static void orientMe(float ang) {
	lx = sin(ang);
	lz = -cos(ang);
	glLoadIdentity();
	gluLookAt(x, y, z,x + lx,y + ly,z + lz,0.0f,1.0f,0.0f);
}

static void gotoCurrentLevel()
{
	if (clevel > fileMap.getNumLevels())
	{
		goDown = clevel - fileMap.getNumLevels();
	} else if (clevel < fileMap.getNumLevels()) {
		goUp = clevel - fileMap.getNumLevels();
	}
}

static void processMouse(int button, int state, int xm, int ym) {
	/*
	* overFile is set to 1 if the mouse is over a file.  
	* It is set to 0 if it is not.
	* This fixes the bug for clicking where there is no file.
	*/
	char wtg[256];
	gchar *name;
	unsigned int level, filenum;
	float oy;

	specialKey = glutGetModifiers();
	if (state == GLUT_DOWN) {
		switch (button)
		{
			case 3:
				if (!mouseMove)
				{
					goUp = 1;
				} else { oldMouseH++; }
				break;
			case 4:
				if (!mouseMove)
				{
					goDown = 1;
				} else { oldMouseH--; }
				break;
			case 0:
				if (overFile)
				{
					level = fileMap.fileNames[*mptr].level;
					filenum = fileMap.fileNames[*mptr].filenum;
					name = fileMap.getName(level, filenum);
					if (!mouseStop)
					{
						if (mptr != 0)
						{
							strcpy(wtg, fileMap.getLevelPath(level));
							if (strcmp (wtg, G_DIR_SEPARATOR_S)) { strcat (wtg, G_DIR_SEPARATOR_S); }
							strcat(wtg, name);
							if (fileMap.is_dir(level, filenum))
							{
								oy = y;
								chdir(wtg);
								fileMap.loadMap();
								y = oy;
								orientMe(angle);
								gotoCurrentLevel();
							} else {
								cout << "execute " << wtg << endl;
							}
						}
						mouseStop = 1;
					}
					g_free(name);
				}
				break;
			case 1:
				if (overFile)
				{
					level = fileMap.fileNames[*mptr].level;
					filenum = fileMap.fileNames[*mptr].filenum;
					name = fileMap.getName(level, filenum);
					if (!mouseStop)
					{
						if (mptr != 0)
						{
							if (fMode < 3)
							{
								strcpy(wtg, fileMap.getLevelPath(level));
								if (strcmp (wtg, G_DIR_SEPARATOR_S))
									strcat (wtg, G_DIR_SEPARATOR_S);
								strcat(wtg, name);
								if (!fSelectCT)
								{
									if (fileMap.is_dir(level, filenum))
									{
										strcpy(fSelect,wtg);
										fSelectCT = 1;
									} else {
										strcpy(fSelect,"Must be Directory");
									}
								} else {
										char sysCom[256];
										switch (fMode)
										{
											case 1:
												strcpy(sysCom,"cp -R ");
												break;
											case 2:
												strcpy(sysCom,"mv ");
												break;
										}
										strcat(sysCom,wtg);
										strcat(sysCom," ");
										strcat(sysCom,fSelect);
										cout << sysCom << endl;
								}
							} else {
								strcpy(wtg, fileMap.getLevelPath(level));
								if (strcmp (wtg, G_DIR_SEPARATOR_S))
									strcat (wtg, G_DIR_SEPARATOR_S);
								strcat(wtg, name);
								if (!fSelectCT)
								{
									strcpy(fSelect,wtg);
									fSelectCT = 1;
								} else if (fSelectCT == 1) {
									fSelectCT++;
								} else if (fSelectCT == 2) {
									char sysCom[256];
									strcpy(sysCom,"rm -r"); // This must done more portable
									strcat(sysCom,wtg);
									cout << sysCom << endl;
								}
							}
						} else {
							memset(fSelect,' ',strlen(fSelect));
							fSelectCT=0; fMode = 0;
						}
						mouseStop = 1;
					}
					g_free(name);
				}
				break;
		}
	}
}

static void processMouseActiveMotion(int x, int y) {
// for future use
}

static void processMousePassiveMotion(int x, int y) {
	xmouse = x;
	ymouse = y;
	if (mouseMove)
	{
		yConv = ((double)y/(double)oldMouseY-1);
		xConv = ((double)x/(double)oldMouseX-1);
	} else {
		oldMouseX = x;
		oldMouseY = y;
	}
}

static void processMouseEntry(int state) {
//for future use
}

static void renderString2(float x,float y,char *string) {
	char *c;
	glRasterPos2f(x, y);
	for (c=string; *c != '\0'; c++) {
		glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, *c);
	}
}

static void renderString3(float x,float y,float z,char *string) {
  char *c;
  glRasterPos3f(x, y, z);
  for (c=string; *c != '\0'; c++) {
    glutBitmapCharacter(GLUT_BITMAP_HELVETICA_18, *c);
  }
}

static void changeSize(int w, int h) {

	if (!h) { h = 1; }
	if (!w) { w = 1; }
	ratio = 1.0f * w / h;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glViewport(0, 0, w, h);
	gluPerspective(45,ratio,1,1000);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(x, y, z,x + lx,y + ly,z + lz,0.0f,1.0f,0.0f);
}

static void initScene() {
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
	glClearColor(0.0f,0.0f,0.0f,1.0f);
	glFogi(GL_FOG_MODE, GL_LINEAR);
	glFogfv(GL_FOG_COLOR, fogColor);
	glFogf(GL_FOG_DENSITY, 0.13f); 
	glHint(GL_FOG_HINT, GL_NICEST);
	glFogf(GL_FOG_START, 65.0f);
	glFogf(GL_FOG_END, 150.0f);
	glEnable(GL_FOG);
        clevel = fileMap.getNumLevels();
}

static void drawCube(float size) {
    glBegin(GL_QUADS);
        glVertex3f( 1.0f, size,-1.0f);          // Top Right Of The Quad (Top)
        glVertex3f(-1.0f, size,-1.0f);          // Top Left Of The Quad (Top)
        glVertex3f(-1.0f, size, 1.0f);          // Bottom Left Of The Quad (Top)
        glVertex3f( 1.0f, size, 1.0f);          // Bottom Right Of The Quad (Top)

        glVertex3f( 1.0f, size, 1.0f);          // Top Right Of The Quad (Front)
        glVertex3f(-1.0f, size, 1.0f);          // Top Left Of The Quad (Front)
        glVertex3f(-1.0f,-1.0f, 1.0f);          // Bottom Left Of The Quad (Front)
        glVertex3f( 1.0f,-1.0f, 1.0f);          // Bottom Right Of The Quad (Front)

        glVertex3f( 1.0f,-1.0f,-1.0f);          // Bottom Left Of The Quad (Back)
        glVertex3f(-1.0f,-1.0f,-1.0f);          // Bottom Right Of The Quad (Back)
        glVertex3f(-1.0f, size,-1.0f);          // Top Right Of The Quad (Back)
        glVertex3f( 1.0f, size,-1.0f);          // Top Left Of The Quad (Back)

        glVertex3f(-1.0f, size, 1.0f);          // Top Right Of The Quad (Left)
        glVertex3f(-1.0f, size,-1.0f);          // Top Left Of The Quad (Left)
        glVertex3f(-1.0f,-1.0f,-1.0f);          // Bottom Left Of The Quad (Left)
        glVertex3f(-1.0f,-1.0f, 1.0f);          // Bottom Right Of The Quad (Left)

        glVertex3f( 1.0f, size,-1.0f);          // Top Right Of The Quad (Right)
        glVertex3f( 1.0f, size, 1.0f);          // Top Left Of The Quad (Right)
        glVertex3f( 1.0f,-1.0f, 1.0f);          // Bottom Left Of The Quad (Right)
        glVertex3f( 1.0f,-1.0f,-1.0f);          // Bottom Right Of The Quad (Right)
    glEnd();
 }

static void drawGround(int size,int height,int z,int ll,int level) {
  	if (ll) { glColor3f(1.0f, 1.0f, 0.0f); } else { glColor3f(0.0f, 0.0f, 1.0f); }

	
	setZ(level, z, z-size);
	glBegin(GL_QUADS);
		glVertex3f(5.0, height, z);
		glVertex3f(70.0, height, z);
		glVertex3f(70.0, height, z-size);
		glVertex3f(5.0, height, z-size);
		glVertex3f(5.0f, 0.0f, z);
		glVertex3f(70.0f, 0.0f, z);
		glVertex3f(70.0f, height, z);
		glVertex3f(5.0f, height, z);
	glEnd();
}


static void getMouseRate() {
	mouseF++;
	mouseTime = glutGet(GLUT_ELAPSED_TIME);
	if (mouseTime - mouseTB > (mouse_delay * 1000)) {
		mouseTB = mouseTime;
		mouseF = 0;
		mouseStop = 0;
	}
}

static void getFPS() {
	frame++;
	ftime = glutGet(GLUT_ELAPSED_TIME);
	if (ftime - timebase > 1000) {
		fps = (frame*1000/(ftime-timebase));
		timebase = ftime;
		frame = 0;
	}
}

static void switchView() {
	view++;
	if (view > 2) { view = 1; }
	switch(view)
	{
		case 2:
			swV2 = 1;
			break;
		case 1:
			swV1 = 1;
			break;
	}
}

static void doAnimations() {
	float levelLoc = 0;
	int totalLevelSize = 0, a, tLevel, dif = 0;
	
	for (a = clevel; a >= 0; a--) {
            totalLevelSize += fileMap.getLevelSize(a) + 1;
        }
	if (swV2)
	{
		//to unanimate, use these values
		//y=totalLevelSize+60;
		//x+=.5;
		//z-=55.0;
		//ly=-20;
		if (tsw < 60)
		{
			x+=.0083333333;
			z-=.91666667;
			ly-=.3333333;
			y=totalLevelSize+tsw;
			orientMe(angle);
			tsw+=1;
		} else { swV2 = 0; tsw = 0; }
	}
	if (goZ > 0)
	{
		if (view == 2) { dif = 0; } else { dif = 55; }
			
		switch (goZ)
		{
			case 3:
				levelLoc = levels[clevel].mloc;
				break;
			case 2:
				levelLoc = levels[clevel].eloc;
				break;
			case 1:
				levelLoc = levels[clevel].zloc;
				break;
		}

		if (!fOrB)
			if (z > levelLoc + dif) { fOrB = 1; } else if (z < levelLoc + dif) { fOrB = 2; } else { fOrB = 3; }
		
		switch (fOrB)
		{
			case 1:
				if (z > levelLoc + dif)
				{
					z -= 1;
					orientMe(angle);
				} else { z = levelLoc + dif; goZ = 0; fOrB = 0; orientMe(angle); }
				break;
			case 2:
				if (z < levelLoc + dif)
				{
					z += 1;
					orientMe(angle);
				} else { z = levelLoc + dif; goZ = 0; fOrB = 0; orientMe(angle); }
				break;
			case 3:
				if (view == 1)
				{
					if (z < 60)
					{
						z += 1;
						orientMe(angle);
					} else { goZ = 0; fOrB = 0; z = 60; orientMe(angle); }
				} else { goZ = 0; fOrB = 0; }
				break;
		}

	}
	if (swV1)
	{
		if (tsw < 60)
		{
			x-=.0083333333;
			z+=.91666667;
			ly+=.3333333;
			y--;
			orientMe(angle);
			tsw+=1;
		} else { swV1 = 0; tsw = 0; }
	}
	if (goDown)
	{
		if (clevel > 0) {
			tLevel = totalLevelSize - fileMap.getLevelSize(clevel);
			if (view == 2) { tLevel += 60; }
			if (y >= tLevel)
			{
				y -= .2;
				orientMe(angle);
			} else {
				goDown--;
				clevel--;
	            orientMe(angle);
			}
		} else {
			goDown = 0;
		}
	}
	if (goUp)
	{
		if (clevel < fileMap.getNumLevels()) {
			tLevel = totalLevelSize + fileMap.getLevelSize(clevel+1) + 2;
			if (view == 2) { tLevel += 60; }
			if (y <= tLevel)
			{
				y += .2;
				orientMe(angle);
			} else {
				goUp--;
				clevel++;
	            orientMe(angle);
			}
		} else {
			goUp = 0;
		}
	}

	//the next couple things are for the mouse movement
	if (mouseMove)
	{
		deltaAngle=(xConv/50);
		y+=(oldMouseH/100);
		moveMeFlat(-(yConv*50));
		orientMe(angle);
	}
}

static void doCubeRotate()
{
	if (rotateCube > 0)
	{
		glRotatef(cr,0.0f,1.0f,0.0f);
		cr+=.05;
		if (cr > 90) { cr = 0; rotateCube = 0; }
	} else if (rotateCube < 0) {
		glRotatef(cr,0.0f,1.0f,0.0f);
		cr-=.05;
		if (cr < -90) { cr = 0; rotateCube = 0; }
	}
}

static void renderIt() {
    int j=1,t,t1,li=1,a,lAmnt=0,ll,rto=0;
    unsigned int totF;
    unsigned int level, t2;
    char whatToDisplay[256];
    gchar *name;

    level = 0;
    if (deltaMove)
        moveMeFlat(deltaMove);
    if (deltaAngle) {
        angle += deltaAngle;
        orientMe(angle);
    }
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    glInitNames();
    t = 0;
    t1 = 0;
    t2 = 0;
    getFPS();
    getMouseRate();
    doAnimations();
    do {
		totF = fileMap.getNumFiles();
        if (level == clevel) { ll = 1; } else { ll = 0; }
        glColor3f(1.0f,1.0f,1.0f);
        renderString3(30,lAmnt+5,j*5, fileMap.getLevelPath(level));
        drawGround(fileMap.getLevelNumFiles(level), lAmnt, j*5, ll, level);
        for (t2 = 0; t2 <= level; t2++) {
            totF -= fileMap.getLevelNumFiles(t2);
        }
        for (a = 0; a < fileMap.getLevelNumFiles(level); a++)
        {
            t++;
            li+=2;
            glPushMatrix();
            glTranslatef(li * 5.0,1 + lAmnt,j * 5.0);
            if (showNames) {
                if (level == clevel || showAllNames) {
                    glTranslatef(0.0f,0.0f,1.0f);
                    glColor3d(0.0f,1.0f,0.0f);
                    switch (displayInfo)
                    {
                    case 3:
                        strftime(whatToDisplay,256,"%m/%d/%Y",fileMap.getDate(level, a));
                        break;
                    case 2:
                        sprintf(whatToDisplay,"%o",fileMap.getPerms(level, a));
                        break;
                    case 1:
                        sprintf (whatToDisplay, "%g", getBoxSize(level, a));
                        break;
                    case 0:
                        name = fileMap.getName(level, a);
                        strcpy(whatToDisplay, name);
                        g_free(name);
                        break;
                    }
                    renderString2(0, getBoxSize(level, a), whatToDisplay);
                    glTranslatef(0.0f,0.0f,-1.0f);
                }
            }
            glPushName(totF);
            if (fileMap.is_dir(level, a)) {
                if (fileMap.is_pdir(level, a))
                    glColor3f(pdirColor[0], pdirColor[1], pdirColor[2]);
                else
                    glColor3f(dirColor[0], dirColor[1], dirColor[2]);
            }
            else
			glColor3f(fileColor[0], fileColor[1], fileColor[2]);
            name = fileMap.getName(level, a);
            if (!strcmp(mouseOver, name) && (fileMap.fileNames[*mptr].level == level)) {
                glColor3d(0.8f,0.8f,0.0f);
            }
            g_free(name);
            if (clevel == level || showAllNames) { doCubeRotate(); }
            drawCube(getBoxSize(level, a));
            glPopName();
            glPopMatrix();
            if (t > 5) {
                j--;
                if (t1) { li = 1; t1 = 0; } else { li = 0; t1 = 1; }
                t = 0;
                rto = 1;
            }
            totF++;
        }
        lAmnt += fileMap.getLevelSize(level) + 1;
        level++;
        if (!rto) { j--; }
        rto = 0;
    } while (level <= fileMap.getNumLevels());
    glutSwapBuffers();
}

static void processHits (GLuint hits, GLuint buffer[]) {
	unsigned int i, j;
	unsigned int level, filenum;
	GLuint names, *ptr, minZ, *ptrNames = 0, numberOfNames = 0;

	ptr = (GLuint *) buffer;
	minZ = 0xffffffff;
	for (i = 0; i < hits; i++) {
		names = *ptr;
		ptr++;
		if (*ptr < minZ) {
			numberOfNames = names;
			minZ = *ptr;
			ptrNames = ptr+2;
		}
		ptr += names+2;
	}
	ptr = ptrNames;
	mptr = ptr;
   /*
    * Why mouseOver is overwritten so much times?
    *
    * Probably this is the reason why on an slow machine
    * is almost impossible to browse a large directory
    * without disabling filenames displaying
    */
	for (j = 0; j < numberOfNames; j++,ptr++) {
		level = fileMap.fileNames[*ptr].level;
		filenum = fileMap.fileNames[*ptr].filenum;
		g_free(mouseOver);
		mouseOver = fileMap.getName(level, filenum);
		overFile++;
	}
}

static void startPicking() {
	GLint viewport[4];

	glSelectBuffer(BUFSIZE,selectBuf);
	glRenderMode(GL_SELECT);

	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();

	glGetIntegerv(GL_VIEWPORT,viewport);
	gluPickMatrix(xmouse,viewport[3]-ymouse,5,5,viewport);
	gluPerspective(45,ratio,0.1,1000);
	glMatrixMode(GL_MODELVIEW);
	glInitNames();
}

static void stopPicking() {
	int hits;

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glFlush();

	hits = glRenderMode(GL_RENDER);

	if (hits != 0)
		processHits(hits,selectBuf);
}

static void setOrtho() {
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	gluOrtho2D(0, wx, 0, wy);
	glScalef(1, -1, 1);
	glTranslatef(0, -wy, 0);
	glMatrixMode(GL_MODELVIEW);
}

static void resetPers() {
	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
}

static void renderScene(void) {
	char fpsBuffer[50],fmodBuff[50];
    overFile = 0;
	switch (fMode)
	{
		case 1:
			strcpy(fmodBuff,"copy: ");
			switch (fSelectCT)
			{
				case 0:
					strcat(fmodBuff,"select location");
					break;
				case 1:
					strcat(fmodBuff,"select file");
					break;
			}
			break;
		case 2:
			strcpy(fmodBuff,"move: ");
			switch (fSelectCT)
			{
				case 0:
					strcat(fmodBuff,"select location");
					break;
				case 1:
					strcat(fmodBuff,"select file");
					break;
			}
			break;
		case 3:
			strcpy(fmodBuff,"delete: ");
			switch (fSelectCT)
			{
				case 0:
					strcat(fmodBuff,"select file");
					break;
				case 1:
					strcat(fmodBuff,"click to confirm");
					break;
				case 2:
					strcat(fmodBuff,"click to delete");
					break;
			}
			break;
		default:
			memset(fmodBuff,' ',strlen(fmodBuff));
			break;
	}
	mptr = 0;
	sprintf (fpsBuffer, "FPS: %7.2f", fps);
	startPicking();
	renderIt();
	stopPicking();
	renderIt();
	setOrtho();
	glPushMatrix();
	glLoadIdentity();
	if (mouseMove) {
		glColor3f(1.0f,0.0f,0.0f);
		/*if (fullscreen)
		{
			renderString2(oldMouseX-60,oldMouseY+50,"x");
		} else {
			renderString2(oldMouseX-6,oldMouseY+5,"x");
		}*/
	}
	glColor3f(1.0f,1.0f,1.0f);
	renderString2(1,15,mouseOver);
	renderString2(1,30,fSelect);
	renderString2(1,45,fpsBuffer);
	renderString2(1,60,fmodBuff);
	glPopMatrix();
	resetPers();
	glutSwapBuffers();
	memset(mouseOver,' ',strlen(mouseOver));
}

static void pressKey(int key, int x, int y) {
	switch (key) {
		case GLUT_KEY_PAGE_UP:
			goUp = 1;
			break;
		case GLUT_KEY_PAGE_DOWN:
			goDown = 1;
			break;
		case GLUT_KEY_LEFT :
			deltaAngle = -0.01f;
			break;
		case GLUT_KEY_RIGHT :
			deltaAngle = 0.01f;
			break;
		case GLUT_KEY_UP :
			deltaMove = 1;
			break;
		case GLUT_KEY_DOWN :
			deltaMove = -1;
			break;
	}
}

static void releaseKey(int key, int x, int y) {
	switch (key) {
		case GLUT_KEY_LEFT :
		case GLUT_KEY_RIGHT :
			deltaAngle = 0.0f;
			break;
		case GLUT_KEY_UP :
		case GLUT_KEY_DOWN:
			deltaMove = 0;
			break;
	}
}

static void processKeys(unsigned char key, int x, int y) {
	int mod;
	switch (key)
	{
		case 9: //tab
			mod = glutGetModifiers();
			if (mod == GLUT_ACTIVE_CTRL)
			{
				displayInfo--;
				if (displayInfo < 0) { displayInfo = 3; }
				rotateCube = -1;
			} else {
				displayInfo++;
				if (displayInfo > 3) { displayInfo = 0; }
				rotateCube = 1;
			}
			break;
		case 110: //n
			showNames = !showNames;
			break;
		case 111: //o
			showAllNames = !showAllNames;
			break;
		case 118: //v
			switchView();
			break;
		case 27: //esc
			exit(0);
			break;
		case 99: //c
			fMode = 1;
			memset(fSelect,' ',strlen(fSelect));
			fSelectCT=0;
			break;
		case 109: //m
			fMode = 2;
			memset(fSelect,' ',strlen(fSelect));
			fSelectCT=0;
			break;
		case 100: //d
			fMode = 3;
			memset(fSelect,' ',strlen(fSelect));
			fSelectCT=0;
			break;
		case 102: //f
			if (fullscreen)
			{
				glutReshapeWindow(wx,wy);
				glutPositionWindow(wxp,wyp);
				fullscreen = 0;
			} else {
				glutFullScreen();
				fullscreen = 1;
			}
			break;
		case 97: //a
			goZ = 3;
			break;
		case 113: //q
			goZ = 2;
			break;
		case 122: //z
			goZ = 1;
			break;
		case 119: //w
			mouseMove = !mouseMove;
			if (!mouseMove) { 
				deltaMove = 0;
				deltaAngle = 0;
				xConv = 0;
				yConv = 0; 
			}
			break;
		case 103: //g
			if (fogOnOff)
			{
				fogOnOff = 0;
				glDisable(GL_FOG);
			} else { fogOnOff = 1; glEnable(GL_FOG); }
			break;
	}
}

static void setVars()
{
    Options opt;

    if (opt.read_options() < 0)
        /*
         * FIXME don't be so drastical, give default values.
         */
		g_error ("Cannot read options, aborting...");
    opt.get_file_color(fileColor);
    opt.get_dir_color(dirColor);
    opt.get_pdir_color(pdirColor);
    opt.get_fog_color(fogColor);
    mouseOver = g_strdup("");
    view = 1;
    goDown = 0;
    goUp = 0;
    showNames = 1;
    showAllNames = 0;
    angle = 0.0f;
    deltaAngle = 0.0f;
    x = 37.5f;
    y = 0.0f;
    z = 55.0f;
    lx = 0.0f;
    ly = 0.0f;
    lz = -1.0f;
    swV1 = 0;
    swV2 = 0;
    tsw = 0;
    goZ = 0;
    fileMap.y = &y; // a terrible hack! must be removed
}

void gui_init ()
{
    setVars();
    fileMap.loadMap();

    glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
    glutInitWindowPosition(wxp,wyp);
    glutInitWindowSize(wx,wy);
    mainWindow = glutCreateWindow("3dFB");
    glutReshapeFunc(changeSize);

    glutIgnoreKeyRepeat(1);
    glutKeyboardFunc(processKeys);
    glutSpecialFunc(pressKey);
    glutSpecialUpFunc(releaseKey);
    glutDisplayFunc(renderScene);
    glutIdleFunc(renderScene);

    //mouse functions
    glutMouseFunc(processMouse);
    glutMotionFunc(processMouseActiveMotion);
    glutPassiveMotionFunc(processMousePassiveMotion);
    glutEntryFunc(processMouseEntry);
    
    initScene();
}
